Bug 8480 - reload ICEs for LAPACK code on powerpc64-linux
Summary: reload ICEs for LAPACK code on powerpc64-linux
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: target (show other bugs)
Version: 3.3
: P3 normal
Target Milestone: ---
Assignee: David Edelsohn
URL:
Keywords: ice-on-valid-code
Depends on:
Blocks:
 
Reported: 2002-11-06 09:26 UTC by janis187
Modified: 2018-03-14 17:27 UTC (History)
1 user (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed:


Attachments
lapack_bug.tar (1.85 KB, application/octet-stream)
2003-05-21 15:17 UTC, janis187
Details

Note You need to log in before you can comment on or make changes to this bug.
Description janis187 2002-11-06 09:26:05 UTC
The three test cases all ICE with gcc version 3.3 20021104
(experimental) for powerpc64-linux, and for GCC 3.2.  They
are all derived from the LAPACK file TESTING/LIN/sdrvgt.f
and are included in the same PR because all three ICEs
might result from the same root cause; if not they can be
split into separate PRs later.

Compiling lapack_bug_O1.f with -O1 gives:

lapack_bug_O1.f: In subroutine `sdrvgt':
lapack_bug_O1.f:46: internal compiler error: in gen_add2_insn, at optabs.c:4196

Compiling lapack_bug_O2_1.f with -O2 gives:

lapack_bug_O2_1.f: In subroutine `sdrvgt':
lapack_bug_O2_1.f:100: error: insn does not satisfy its constraints:
(insn 750 749 676 9 (nil) (set (reg/f:DI 59 f27 [244])
        (plus:DI (reg/f:DI 59 f27 [244])
            (const_int 288 [0x120]))) 226 {*adddi3_internal1} (nil)
    (expr_list:REG_EQUIV (plus:DI (reg/f:DI 1 r1)
            (const_int 288 [0x120]))
   lapack_bug_O2_1.f:100: internal compiler error: in reload_cse_simplify_operands, at reload1.c:8331

Compiling lapack_bug_O2_2.f with -O2 gives:

lapack_bug_O2_2.f: In subroutine `sdrvgt':
lapack_bug_O2_2.f:78: internal compiler error: in reload, at reload1.c:1109     (nil)))

Release:
3.3 20021104 (experimental) and 3.2

Environment:
powerpc64-linux

How-To-Repeat:
See description.
Comment 1 David Edelsohn 2002-11-06 16:35:27 UTC
Responsible-Changed-From-To: unassigned->dje
Responsible-Changed-Why: PowerPC
Comment 2 David Edelsohn 2002-11-06 16:35:27 UTC
State-Changed-From-To: open->closed
State-Changed-Why: fixed
Comment 3 CVS Commits 2005-01-05 09:17:17 UTC
Subject: Bug 8480

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-3_2-rhl8-branch
Changes by:	jakub@gcc.gnu.org	2005-01-05 09:17:00

Modified files:
	gcc            : ChangeLog 
	gcc/config/rs6000: rs6000.md 
	gcc/testsuite  : ChangeLog 
Added files:
	gcc/testsuite/gcc.dg: pr8328.c 

Log message:
	2004-07-25  David Edelsohn  <edelsohn@gnu.org>
	
	PR target/16239
	* config/rs6000/rs6000.md (movdi_internal64): Further disparage
	f->f.
	
	2002-11-06  David Edelsohn  <edelsohn@gnu.org>
	
	PR target/8480, optimization/8328
	* config/rs6000/rs6000.md (movdi_internal64): Discourage
	FPR to FPR moves.
	
	2004-12-22  Ben Elliston  <bje@au.ibm.com>
	
	PR optimization/8328
	* gcc.dg/pr8328.c: New test.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_2-rhl8-branch&r1=1.13152.2.657.2.27.2.208&r2=1.13152.2.657.2.27.2.209
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/config/rs6000/rs6000.md.diff?cvsroot=gcc&only_with_tag=gcc-3_2-rhl8-branch&r1=1.170.2.11.4.12&r2=1.170.2.11.4.13
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_2-rhl8-branch&r1=1.1672.2.166.2.8.2.89&r2=1.1672.2.166.2.8.2.90
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gcc.dg/pr8328.c.diff?cvsroot=gcc&only_with_tag=gcc-3_2-rhl8-branch&r1=NONE&r2=1.1.2.1

Comment 4 Martin Liška 2018-03-14 17:27:10 UTC
Author: marxin
Date: Wed Mar 14 17:26:38 2018
New Revision: 258529

URL: https://gcc.gnu.org/viewcvs?rev=258529&root=gcc&view=rev
Log:
Add test-case (PR ipa/84805).

2018-03-14  Martin Liska  <mliska@suse.cz>

	PR ipa/8480
	* g++.dg/lto/pr84805_0.C: New test.
	* g++.dg/lto/pr84805_1.C: New test.
	* g++.dg/lto/pr84805_2.C: New test.

Added:
    trunk/gcc/testsuite/g++.dg/lto/pr84805_0.C
    trunk/gcc/testsuite/g++.dg/lto/pr84805_1.C
    trunk/gcc/testsuite/g++.dg/lto/pr84805_2.C
Modified:
    trunk/gcc/testsuite/ChangeLog